Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5600)
@@ -5,32 +5,47 @@
 ! MODULE: mpp
 !
-!
 ! DESCRIPTION:
-!> This module manage massively parallel processing
+!> @brief
+!> This module manage massively parallel processing.
 !
 !> @details
 !> define type TMPP:<br/>
-!> TYPE(TMPP) :: tl_mpp<br/>
+!> @code
+!> TYPE(TMPP) :: tl_mpp
+!> @endcode
 !>
 !>    to initialise a mpp structure:<br/>
-!>    - tl_mpp=mpp_init( cd_file, id_mask, [id_niproc,] [id_njproc,] 
-!>         [id_nproc] [id_preci,] [id_precj,] [cd_type])
-!>    - tl_mpp=mpp_init( cd_file, td_var, [id_niproc,] [id_njproc,] 
-!>         [id_nproc] [id_preci,] [id_precj,] [cd_type])
-!>    - tl_mpp=mpp_init( td_file )
+!> @code
+!>    tl_mpp=mpp_init( cd_file, id_mask, 
+!>                       [id_niproc,] [id_njproc,] [id_nproc,]
+!>                       [id_preci,] [id_precj,] 
+!>                       [cd_type,] [id_ew])
+!> @endcode
+!> or
+!> @code
+!>    tl_mpp=mpp_init( cd_file, td_var, 
+!>                      [id_niproc,] [id_njproc,] [id_nproc,]
+!>                      [id_preci,] [id_precj,]
+!>                      [cd_type] )
+!> @endcode
+!> or
+!> @code
+!>    tl_mpp=mpp_init( td_file [,id_ew] )
+!> @endcode
 !>       - cd_file is the filename of the global domain file, in which 
 !>         MPP will be done (example: Bathymetry) 
 !>       - td_file is the file structure of one processor file composing an MPP
-!>       - id_mask is the 2D mask of global domain 
+!>       - id_mask is the 2D mask of global domain [optional]
 !>       - td_var is a variable structure (on T-point) from global domain file.
-!>         mask of the domain will be computed using FillValue
+!>         mask of the domain will be computed using FillValue [optional]
 !>       - id_niproc is the number of processor following I-direction to be used
-!>         (optional)
+!>         [optional]
 !>       - id_njproc is the number of processor following J-direction to be used 
-!>         (optional)
-!>       - id_nproc is the total number of processor to be used (optional)
-!>       - id_preci is the size of the overlap region following I-direction
-!>       - id_precj is the size of the overlap region following J-direction
-!>       - cd_type is the type of files composing MPP<br/>
+!>         [optional]
+!>       - id_nproc is the total number of processor to be used [optional]
+!>       - id_preci is the size of the overlap region following I-direction [optional]
+!>       - id_precj is the size of the overlap region following J-direction [optional]
+!>       - cd_type is the type of files composing MPP [optional]
+!>       - id_ew is east-west overlap [optional]<br/> 
 !>  
 !>    to get mpp name:<br/>
@@ -62,5 +77,5 @@
 !>    - tl_mpp\%i_ndim
 !>
-!>    to get the table of dimension structure (4 elts) associated to the
+!>    to get the array of dimension structure (4 elts) associated to the
 !>    mpp structure:<br/>
 !>    - tl_mpp\%t_dim(:)
@@ -70,50 +85,110 @@
 !>
 !>    to clean a mpp structure:<br/>
-!>    - CALL mpp_clean(tl_mpp)
+!> @code
+!>    CALL mpp_clean(tl_mpp)
+!> @endcode
 !>
 !>    to print information about mpp:<br/>
+!> @code
 !>    CALL mpp_print(tl_mpp)
+!> @endcode
 !>
 !>    to add variable to mpp:<br/>
+!> @code
 !>    CALL mpp_add_var(td_mpp, td_var)
+!> @endcode
 !>       - td_var is a variable structure
 !>
 !>    to add dimension to mpp:<br/>
+!> @code
 !>    CALL mpp_add_dim(td_mpp, td_dim)
+!> @endcode
 !>       - td_dim is a dimension structure
 !>
-!>    to delete variable to mpp:<br/>
+!>    to add attribute to mpp:<br/>
+!> @code
+!>    CALL mpp_add_att(td_mpp, td_att)
+!> @endcode
+!>       - td_att is a attribute structure
+!>
+!>    to delete variable from mpp:<br/>
+!> @code
 !>    CALL mpp_del_var(td_mpp, td_var)
+!> @endcode
+!>    or
+!> @code
+!>    CALL mpp_del_var(td_mpp, cd_name)
+!> @endcode
 !>       - td_var is a variable structure
+!>       - cd_name is variable name or standard name
 !>
-!>    to delete dimension to mpp:<br/>
+!>    to delete dimension from mpp:<br/>
+!> @code
 !>    CALL mpp_del_dim(td_mpp, td_dim)
+!> @endcode
 !>       - td_dim is a dimension structure
 !>
+!>    to delete attribute from mpp:<br/>
+!> @code
+!>    CALL mpp_del_att(td_mpp, td_att)
+!> @endcode
+!>    or
+!> @code
+!>    CALL mpp_del_att(td_mpp, cd_name)
+!> @endcode
+!>       - td_att is a attribute structure
+!>       - cd_name is attribute name
+!>
 !>    to overwrite variable to mpp:<br/>
+!> @code
 !>    CALL mpp_move_var(td_mpp, td_var)
+!> @endcode
 !>       - td_var is a variable structure
 !>
 !>    to overwrite dimension to mpp:<br/>
+!> @code
 !>    CALL mpp_move_dim(td_mpp, td_dim)
+!> @endcode
 !>       - td_dim is a dimension structure
 !>
+!>    to overwrite attribute to mpp:<br/>
+!> @code
+!>    CALL mpp_move_att(td_mpp, td_att)
+!> @endcode
+!>       - td_att is a attribute structure
+!>
 !>    to determine domain decomposition type:<br/>
+!> @code
 !>    CALL mpp_get_dom(td_mpp)
+!> @endcode
 !>
 !>    to get processors to be used:<br/>
-!>    CALL mpp_get_use( td_mpp, td_dom )
-!>       - td_dom is a domain structure
+!> @code
+!>    CALL mpp_get_use( td_mpp, id_imin, id_imax, id_idim, & 
+!>    &                         id_jmin, id_jmax, id_jdim )
+!> @endcode
+!>       - id_imin 
+!>       - id_imax 
+!>       - id_idim 
+!>       - id_jmin 
+!>       - id_jmax 
+!>       - id_jdim 
 !>
 !>    to get sub domains which form global domain contour:<br/>
+!> @code
 !>    CALL mpp_get_contour( td_mpp ) 
+!> @endcode
 !>
 !>    to get global domain indices of one processor:<br/>
+!> @code
 !>    il_ind(1:4)=mpp_get_proc_index( td_mpp, id_procid )
+!> @endcode
 !>       - il_ind(1:4) are global domain indices (i1,i2,j1,j2)
 !>       - id_procid is the processor id
 !>
 !>    to get the processor domain size:<br/>
+!> @code
 !>    il_size(1:2)=mpp_get_proc_size( td_mpp, id_procid )
+!> @endcode
 !>       - il_size(1:2) are the size of domain following I and J
 !>       - id_procid is the processor id
@@ -122,16 +197,13 @@
 !>  J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!> @todo
-!>  - add description generique de l'objet mpp
-!>  - mpp_print
-!>  - voir pour mettre cd_file systematiquement pour mpp_init
-!>  + modifier utilisation la haut
+!> @date November, 2013 - Initial Version
+!> @date November, 2014 - Fix memory leaks bug
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
 !----------------------------------------------------------------------
 MODULE mpp
+   USE global                          ! global parameter
    USE kind                            ! F90 kind parameter
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE fct                             ! basic useful function
    USE dim                             ! dimension manager
@@ -140,15 +212,12 @@
    USE file                            ! file manager
    USE iom                             ! I/O manager
-!   USE proc                            ! proc manager
-   USE dom                             ! domain manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
    ! type and variable
-   PUBLIC :: TMPP       ! mpp structure
+   PUBLIC :: TMPP       !< mpp structure
 
    ! function and subroutine
-   PUBLIC :: ASSIGNMENT(=)      !< copy mpp structure
+   PUBLIC :: mpp_copy           !< copy mpp structure
    PUBLIC :: mpp_init           !< initialise mpp structure
    PUBLIC :: mpp_clean          !< clean mpp strcuture
@@ -163,4 +232,6 @@
    PUBLIC :: mpp_move_dim       !< overwrite one dimension strucutre in mpp structure
    PUBLIC :: mpp_move_att       !< overwrite one attribute strucutre in mpp structure
+   PUBLIC :: mpp_recombine_var  !< recombine variable from mpp structure
+   PUBLIC :: mpp_get_index      !< return index of mpp 
 
    PUBLIC :: mpp_get_dom        !< determine domain decomposition type (full, overlap, noverlap)
@@ -170,40 +241,66 @@
    PUBLIC :: mpp_get_proc_size  !< get processor domain size
 
-   PRIVATE :: mpp__add_proc     !< add one proc strucutre in mpp structure
-   PRIVATE :: mpp__del_proc     !< delete one proc strucutre in mpp structure
-   PRIVATE :: mpp__move_proc    !< overwrite proc strucutre in mpp structure
-   PRIVATE :: mpp__compute      !< compute domain decomposition
-   PRIVATE :: mpp__del_land     !< remove land sub domain from domain decomposition
-   PRIVATE :: mpp__optimiz      !< compute optimum domain decomposition
-   PRIVATE :: mpp__land_proc    !< check if processor is a land processor
-   PRIVATE :: mpp__check_dim    !< check mpp structure dimension with proc or variable dimension
-   PRIVATE :: mpp__del_var_name !< delete variable in mpp structure, given variable name
-   PRIVATE :: mpp__del_var_str  !< delete variable in mpp structure, given variable structure
-   PRIVATE :: mpp__del_att_name !< delete variable in mpp structure, given variable name
-   PRIVATE :: mpp__del_att_str  !< delete variable in mpp structure, given variable structure
-   PRIVATE :: mpp__split_var    !< extract variable part that will be written in processor 
-   PRIVATE :: mpp__copy         !< copy mpp structure
-
-   !> @struct TMPP
-   TYPE TMPP
+   PRIVATE :: mpp__add_proc            ! add one proc strucutre in mpp structure
+   PRIVATE :: mpp__del_proc            ! delete one proc strucutre in mpp structure
+   PRIVATE :: mpp__del_proc_id         ! delete one proc strucutre in mpp structure, given procesor id
+   PRIVATE :: mpp__del_proc_str        ! delete one proc strucutre in mpp structure, given procesor file structure 
+   PRIVATE :: mpp__move_proc           ! overwrite proc strucutre in mpp structure
+   PRIVATE :: mpp__compute             ! compute domain decomposition
+   PRIVATE :: mpp__del_land            ! remove land sub domain from domain decomposition
+   PRIVATE :: mpp__optimiz             ! compute optimum domain decomposition
+   PRIVATE :: mpp__land_proc           ! check if processor is a land processor
+   PRIVATE :: mpp__check_dim           ! check mpp structure dimension with proc or variable dimension
+   PRIVATE :: mpp__check_proc_dim      ! check if processor and mpp structure use same dimension
+   PRIVATE :: mpp__check_var_dim       ! check if variable  and mpp structure use same dimension
+   PRIVATE :: mpp__del_var_name        ! delete variable in mpp structure, given variable name
+   PRIVATE :: mpp__del_var_mpp         ! delete all variable in mpp structure
+   PRIVATE :: mpp__del_var_str         ! delete variable in mpp structure, given variable structure
+   PRIVATE :: mpp__del_att_name        ! delete variable in mpp structure, given variable name
+   PRIVATE :: mpp__del_att_str         ! delete variable in mpp structure, given variable structure
+   PRIVATE :: mpp__split_var           ! extract variable part that will be written in processor 
+   PRIVATE :: mpp__copy_unit           ! copy mpp structure
+   PRIVATE :: mpp__copy_arr            ! copy array of mpp structure
+   PRIVATE :: mpp__get_use_unit        ! get sub domains to be used (which cover "zoom domain")
+   PRIVATE :: mpp__init_mask           ! initialise mpp structure, given file name
+   PRIVATE :: mpp__init_var            ! initialise mpp structure, given variable strcuture
+   PRIVATE :: mpp__init_file           ! initialise a mpp structure, given file structure 
+   PRIVATE :: mpp__init_file_cdf       ! initialise a mpp structure with cdf file
+   PRIVATE :: mpp__init_file_rstdimg   ! initialise a mpp structure with rstdimg file
+   PRIVATE :: mpp__clean_unit          ! clean mpp strcuture
+   PRIVATE :: mpp__clean_arr           ! clean array of mpp strcuture
+
+   TYPE TMPP !< mpp structure
 
       ! general 
-      CHARACTER(LEN=lc)                   :: c_name = ''   !< base name ???
-
-      INTEGER(i4)                         :: i_niproc = 0         !< number of processors following i
-      INTEGER(i4)                         :: i_njproc = 0         !< number of processors following j
-      INTEGER(i4)                         :: i_nproc  = 0         !< total number of proccessors used
-      INTEGER(i4)                         :: i_preci = 1          !< i-direction overlap region length
-      INTEGER(i4)                         :: i_precj = 1          !< j-direction overlap region length
-
-      CHARACTER(LEN=lc)                   :: c_type = ''   !< type of the files (cdf, cdf4, dimg)
-      CHARACTER(LEN=lc)                   :: c_dom  = ''   !< type of domain (full, overlap, nooverlap)
-
-      INTEGER(i4)                         :: i_ndim = 0           !< number of dimensions used in mpp
-      TYPE(TDIM),  DIMENSION(ip_maxdim)   :: t_dim                !< global domain dimension
-
-      TYPE(TFILE), DIMENSION(:), POINTER  :: t_proc => NULL()     !< files/processors composing mpp
+      CHARACTER(LEN=lc)                  :: c_name = ''   !< base name 
+      INTEGER(i4)                        :: i_id   = 0    !< mpp id
+
+      INTEGER(i4)                        :: i_niproc = 0  !< number of processors following i
+      INTEGER(i4)                        :: i_njproc = 0  !< number of processors following j
+      INTEGER(i4)                        :: i_nproc  = 0  !< total number of proccessors used
+      INTEGER(i4)                        :: i_preci = 1   !< i-direction overlap region length
+      INTEGER(i4)                        :: i_precj = 1   !< j-direction overlap region length
+      INTEGER(i4)                        :: i_ew    = -1  !< east-west overlap
+      INTEGER(i4)                        :: i_perio = -1  !< NEMO periodicity index
+      INTEGER(i4)                        :: i_pivot = -1  !< NEMO pivot point index F(0),T(1)
+
+      CHARACTER(LEN=lc)                  :: c_type = ''   !< type of the files (cdf, cdf4, dimg)
+      CHARACTER(LEN=lc)                  :: c_dom  = ''   !< type of domain (full, overlap, nooverlap)
+
+      INTEGER(i4)                        :: i_ndim = 0    !< number of dimensions used in mpp
+      TYPE(TDIM),  DIMENSION(ip_maxdim)  :: t_dim         !< global domain dimension
+
+      TYPE(TFILE), DIMENSION(:), POINTER :: t_proc => NULL()     !< files/processors composing mpp
 
    END TYPE
+
+   INTERFACE mpp_get_use
+      MODULE PROCEDURE mpp__get_use_unit 
+   END INTERFACE mpp_get_use
+
+   INTERFACE mpp_clean
+      MODULE PROCEDURE mpp__clean_unit 
+      MODULE PROCEDURE mpp__clean_arr   
+   END INTERFACE mpp_clean
 
    INTERFACE mpp__check_dim
@@ -220,4 +317,5 @@
       MODULE PROCEDURE mpp__del_var_name
       MODULE PROCEDURE mpp__del_var_str
+      MODULE PROCEDURE mpp__del_var_mpp
    END INTERFACE mpp_del_var
 
@@ -230,9 +328,10 @@
       MODULE PROCEDURE mpp__init_mask
       MODULE PROCEDURE mpp__init_var
-      MODULE PROCEDURE mpp__init_read
+      MODULE PROCEDURE mpp__init_file
    END INTERFACE mpp_init
 
-   INTERFACE ASSIGNMENT(=)
-      MODULE PROCEDURE mpp__copy   ! copy mpp structure
+   INTERFACE mpp_copy
+      MODULE PROCEDURE mpp__copy_unit  ! copy mpp structure
+      MODULE PROCEDURE mpp__copy_arr   ! copy array of mpp structure
    END INTERFACE
 
@@ -240,23 +339,34 @@
    !-------------------------------------------------------------------
    !> @brief
-   !> This subroutine copy mpp structure in another mpp
-   !> structure
+   !> This subroutine copy mpp structure in another one
    !> @details 
-   !> mpp file are copied in a temporary table, 
+   !> mpp file are copied in a temporary array, 
    !> so input and output mpp structure do not point on the same 
    !> "memory cell", and so on are independant. 
    !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[out] td_mpp1  : mpp structure
-   !> @param[in] td_mpp2  : mpp structure
-   !-------------------------------------------------------------------
-   ! @code
-   SUBROUTINE mpp__copy( td_mpp1, td_mpp2 )
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_file=file_copy(file_init()) is forbidden).
+   !> This will create memory leaks.
+   !> @warning to avoid infinite loop, do not use any function inside 
+   !> this subroutine
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
+   !
+   !> @param[in] td_mpp   mpp structure
+   !> @return copy of input mpp structure
+   !-------------------------------------------------------------------
+   FUNCTION mpp__copy_unit( td_mpp )
       IMPLICIT NONE
       ! Argument
-      TYPE(TMPP), INTENT(OUT) :: td_mpp1
-      TYPE(TMPP), INTENT(IN)  :: td_mpp2
+      TYPE(TMPP), INTENT(IN)  :: td_mpp
+      ! function
+      TYPE(TMPP) :: mpp__copy_unit
+
+      ! local variable
+      TYPE(TFILE) :: tl_file
 
       ! loop indices
@@ -264,31 +374,80 @@
       !----------------------------------------------------------------
 
-      CALL logger_trace("COPY: mpp "//TRIM(td_mpp2%c_name)//" in "//&
-      &  TRIM(td_mpp1%c_name))
+      CALL logger_trace("MPP COPY: "//TRIM(td_mpp%c_name)//" in "//&
+      &  TRIM(mpp__copy_unit%c_name))
+
       ! copy mpp variable
-      td_mpp1%c_name     = TRIM(td_mpp2%c_name)
-      td_mpp1%i_niproc   = td_mpp2%i_niproc
-      td_mpp1%i_njproc   = td_mpp2%i_njproc
-      td_mpp1%i_nproc    = td_mpp2%i_nproc
-      td_mpp1%i_preci    = td_mpp2%i_preci
-      td_mpp1%i_precj    = td_mpp2%i_precj
-      td_mpp1%c_type     = TRIM(td_mpp2%c_type)
-      td_mpp1%c_dom      = TRIM(td_mpp2%c_dom)
-      td_mpp1%i_ndim     = td_mpp2%i_ndim
+      mpp__copy_unit%c_name     = TRIM(td_mpp%c_name)
+      mpp__copy_unit%i_niproc   = td_mpp%i_niproc
+      mpp__copy_unit%i_njproc   = td_mpp%i_njproc
+      mpp__copy_unit%i_nproc    = td_mpp%i_nproc
+      mpp__copy_unit%i_preci    = td_mpp%i_preci
+      mpp__copy_unit%i_precj    = td_mpp%i_precj
+      mpp__copy_unit%c_type     = TRIM(td_mpp%c_type)
+      mpp__copy_unit%c_dom      = TRIM(td_mpp%c_dom)
+      mpp__copy_unit%i_ndim     = td_mpp%i_ndim
+      mpp__copy_unit%i_ew       = td_mpp%i_ew
+      mpp__copy_unit%i_perio    = td_mpp%i_perio
+      mpp__copy_unit%i_pivot    = td_mpp%i_pivot
 
       ! copy dimension
-      td_mpp1%t_dim(:) = td_mpp2%t_dim(:)
+      mpp__copy_unit%t_dim(:) = dim_copy(td_mpp%t_dim(:))
       
       ! copy file structure
-      IF( ASSOCIATED(td_mpp1%t_proc) ) DEALLOCATE(td_mpp1%t_proc)
-      IF( ASSOCIATED(td_mpp2%t_proc) )THEN
-         ALLOCATE( td_mpp1%t_proc(td_mpp1%i_nproc) )
-         DO ji=1,td_mpp1%i_nproc
-            td_mpp1%t_proc(ji) = td_mpp2%t_proc(ji)
+      IF( ASSOCIATED(mpp__copy_unit%t_proc) )THEN
+         CALL file_clean(mpp__copy_unit%t_proc(:))
+         DEALLOCATE(mpp__copy_unit%t_proc)
+      ENDIF
+      IF( ASSOCIATED(td_mpp%t_proc) .AND. mpp__copy_unit%i_nproc > 0 )THEN
+         ALLOCATE( mpp__copy_unit%t_proc(mpp__copy_unit%i_nproc) )
+         DO ji=1,mpp__copy_unit%i_nproc
+            tl_file = file_copy(td_mpp%t_proc(ji))
+            mpp__copy_unit%t_proc(ji) = file_copy(tl_file)
          ENDDO
-      ENDIF
-
-   END SUBROUTINE mpp__copy
-   ! @endcode
+         ! clean
+         CALL file_clean(tl_file)
+      ENDIF
+
+   END FUNCTION mpp__copy_unit
+   !-------------------------------------------------------------------
+   !> @brief
+   !> This subroutine copy an array of mpp structure in another one
+   !> @details 
+   !> mpp file are copied in a temporary array, 
+   !> so input and output mpp structure do not point on the same 
+   !> "memory cell", and so on are independant. 
+   !>
+   !> @warning do not use on the output of a function who create or read an
+   !> structure (ex: tl_file=file_copy(file_init()) is forbidden).
+   !> This will create memory leaks.
+   !> @warning to avoid infinite loop, do not use any function inside 
+   !> this subroutine
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !> @date November, 2014
+   !>    - use function instead of overload assignment operator 
+   !> (to avoid memory leak)
+   !>
+   !> @param[in] td_mpp   mpp structure
+   !> @return copy of input array of mpp structure
+   !-------------------------------------------------------------------
+   FUNCTION mpp__copy_arr( td_mpp )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TMPP), DIMENSION(:), INTENT(IN)  :: td_mpp
+      ! function
+      TYPE(TMPP), DIMENSION(SIZE(td_mpp(:))) :: mpp__copy_arr
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      DO ji=1,SIZE(td_mpp(:))
+         mpp__copy_arr(ji)=mpp_copy(td_mpp(ji))
+      ENDDO
+
+   END FUNCTION mpp__copy_arr
    !-------------------------------------------------------------------
    !> @brief This subroutine print some information about mpp strucutre.
@@ -297,7 +456,6 @@
    !> - Nov, 2013- Initial Version
    !
-   !> @param[in] td_mpp : mpp structure
-   !-------------------------------------------------------------------
-   ! @code
+   !> @param[in] td_mpp mpp structure
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_print(td_mpp)
       IMPLICIT NONE
@@ -307,5 +465,5 @@
 
       ! local variable
-      INTEGER(i4), PARAMETER :: ip_freq = 4
+      INTEGER(i4), PARAMETER :: il_freq = 4
 
       INTEGER(i4), DIMENSION(:,:), ALLOCATABLE :: il_proc
@@ -321,5 +479,5 @@
       !----------------------------------------------------------------
 
-      WRITE(*,'((a,a),2(/3x,a,a),6(/3x,a,i0))')&
+      WRITE(*,'((a,a),2(/3x,a,a),9(/3x,a,i0))')&
       &  "MPP : ",TRIM(td_mpp%c_name), &
       &  " type   : ",TRIM(td_mpp%c_type), &
@@ -330,5 +488,8 @@
       &  " preci  : ",td_mpp%i_preci, &
       &  " precj  : ",td_mpp%i_precj, &
-      &  " ndim   : ",td_mpp%i_ndim
+      &  " ndim   : ",td_mpp%i_ndim,  &
+      &  " overlap: ",td_mpp%i_ew, &
+      &  " perio  : ",td_mpp%i_perio, &
+      &  " pivot  : ",td_mpp%i_pivot
 
       ! print dimension
@@ -363,11 +524,12 @@
                &  td_mpp%t_proc(ji)%i_lej
 
-               !! attribute
-               !DO jj=1, td_mpp%t_proc(ji)%i_natt
-               !   CALL att_print(td_mpp%t_proc(ji)%t_att(jj))
-               !ENDDO
-
-
             ENDDO
+
+            IF( td_mpp%t_proc(1)%i_nvar > 0 )THEN
+               WRITE(*,'(/a)') " Variable(s) used : "
+               DO ji=1,td_mpp%t_proc(1)%i_nvar
+                  WRITE(*,'(3x,a)') TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name) 
+               ENDDO
+            ENDIF
 
          ELSE
@@ -387,11 +549,13 @@
                &  td_mpp%t_proc(ji)%i_lej
 
-               !! attribute
-               !DO jj=1, td_mpp%t_proc(ji)%i_natt
-               !   CALL att_print(td_mpp%t_proc(ji)%t_att(jj))
-               !ENDDO
-
             ENDDO
             
+            IF( td_mpp%t_proc(1)%i_nvar > 0 )THEN
+               WRITE(*,'(/a)') " Variable(s) used : "
+               DO ji=1,td_mpp%t_proc(1)%i_nvar
+                  WRITE(*,'(3x,a)') TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name) 
+               ENDDO
+            ENDIF
+
             ALLOCATE( il_proc(td_mpp%i_niproc,td_mpp%i_njproc) )
             ALLOCATE( il_lci(td_mpp%i_niproc,td_mpp%i_njproc) )
@@ -407,6 +571,6 @@
 
             jl = 1
-            DO jk = 1,(td_mpp%i_niproc-1)/ip_freq+1
-               jm = MIN(td_mpp%i_niproc, jl+ip_freq-1)
+            DO jk = 1,(td_mpp%i_niproc-1)/il_freq+1
+               jm = MIN(td_mpp%i_niproc, jl+il_freq-1)
                WRITE(*,*)
                WRITE(*,9401) (ji, ji = jl,jm)
@@ -419,5 +583,5 @@
                   WRITE(*,9400) ('***', ji = jl,jm-1)
                ENDDO
-               jl = jl+ip_freq
+               jl = jl+il_freq
             ENDDO
          
@@ -439,9 +603,8 @@
 
    END SUBROUTINE mpp_print
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function initialised mpp structure, given file name, mask and number of
-   !> processor following I and J
+   !> This function initialise mpp structure, given file name, 
+   !> and optionaly mask and number of processor following I and J
    !> @detail
    !> - If no total number of processor is defined (id_nproc), optimize 
@@ -452,25 +615,27 @@
    !
    !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[in] cd_file : file name of one file composing mpp domain
-   !> @param[in] id_mask : domain mask
-   !> @param[in] id_niproc : number of processors following i
-   !> @param[in] id_njproc : number of processors following j
-   !> @param[in] id_nproc  : total number of processors
-   !> @param[in] id_preci  : i-direction overlap region
-   !> @param[in] id_precj  : j-direction overlap region
-   !> @param[in] cd_type   : type of the files (cdf, cdf4, dimg)
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[in] cd_file   file name of one file composing mpp domain
+   !> @param[in] id_mask   domain mask
+   !> @param[in] id_niproc number of processors following i
+   !> @param[in] id_njproc number of processors following j
+   !> @param[in] id_nproc  total number of processors
+   !> @param[in] id_preci  i-direction overlap region
+   !> @param[in] id_precj  j-direction overlap region
+   !> @param[in] cd_type   type of the files (cdf, cdf4, dimg)
+   !> @param[in] id_ew     east-west overlap
+   !> @param[in] id_perio  NEMO periodicity index
+   !> @param[in] id_pivot  NEMO pivot point index F(0),T(1)
    !> @return mpp structure
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TMPP) FUNCTION mpp__init_mask(cd_file, id_mask,              &
    &                                  id_niproc, id_njproc, id_nproc,&
    &                                  id_preci, id_precj,            &
-                                      cd_type)
+                                      cd_type, id_ew, id_perio, id_pivot)
       IMPLICIT NONE
       ! Argument
       CHARACTER(LEN=*),            INTENT(IN) :: cd_file
-      INTEGER(i4), DIMENSION(:,:), INTENT(IN), OPTIONAL :: id_mask
+      INTEGER(i4), DIMENSION(:,:), INTENT(IN) :: id_mask
       INTEGER(i4),                 INTENT(IN), OPTIONAL :: id_niproc
       INTEGER(i4),                 INTENT(IN), OPTIONAL :: id_njproc
@@ -479,4 +644,7 @@
       INTEGER(i4),                 INTENT(IN), OPTIONAL :: id_precj
       CHARACTER(LEN=*),            INTENT(IN), OPTIONAL :: cd_type
+      INTEGER(i4),                 INTENT(IN), OPTIONAL :: id_ew
+      INTEGER(i4),                 INTENT(IN), OPTIONAL :: id_perio
+      INTEGER(i4),                 INTENT(IN), OPTIONAL :: id_pivot
 
       ! local variable
@@ -494,7 +662,4 @@
       ! clean mpp
       CALL mpp_clean(mpp__init_mask)
-
-      ! get mpp name
-      mpp__init_mask%c_name=TRIM(file_rename(cd_file))
 
       ! check type
@@ -518,14 +683,18 @@
       ENDIF
 
-      IF( PRESENT(id_mask) )THEN
-         ! get global domain dimension
-         il_shape(:)=SHAPE(id_mask)
-
-         tl_dim=dim_init('X',il_shape(1))
-         CALL mpp_add_dim(mpp__init_mask, tl_dim)
-
-         tl_dim=dim_init('Y',il_shape(2))
-         CALL mpp_add_dim(mpp__init_mask,tl_dim)
-      ENDIF
+      ! get mpp name
+      mpp__init_mask%c_name=TRIM(file_rename(cd_file))
+
+      ! get global domain dimension
+      il_shape(:)=SHAPE(id_mask)
+
+      tl_dim=dim_init('X',il_shape(1))
+      CALL mpp_add_dim(mpp__init_mask, tl_dim)
+
+      tl_dim=dim_init('Y',il_shape(2))
+      CALL mpp_add_dim(mpp__init_mask, tl_dim)
+
+      ! clean
+      CALL dim_clean(tl_dim)
 
       IF( (       PRESENT(id_niproc)  .AND. (.NOT. PRESENT(id_niproc))) .OR. &
@@ -546,4 +715,10 @@
       IF( PRESENT(id_precj) ) mpp__init_mask%i_precj= id_precj
 
+      ! east-west overlap
+      IF( PRESENT(id_ew) ) mpp__init_mask%i_ew= id_ew
+      ! NEMO periodicity
+      IF( PRESENT(id_perio) ) mpp__init_mask%i_perio= id_perio
+      IF( PRESENT(id_pivot) ) mpp__init_mask%i_pivot= id_pivot
+
       IF( mpp__init_mask%i_nproc  /= 0 .AND. &
       &   mpp__init_mask%i_niproc /= 0 .AND. &
@@ -560,5 +735,6 @@
       ELSE
 
-         IF( mpp__init_mask%i_niproc /= 0 .AND. mpp__init_mask%i_njproc /= 0 )THEN
+         IF( mpp__init_mask%i_niproc /= 0 .AND. &
+         &   mpp__init_mask%i_njproc /= 0 )THEN
             ! compute domain decomposition
             CALL mpp__compute( mpp__init_mask )
@@ -570,9 +746,14 @@
 
          ELSE
-            CALL logger_error("MPP INIT: can't define domain decomposition")
-            CALL logger_debug ("MPP INIT: maximum number of processor to be used "//&
-            &  "or number of processor following I and J direction must "//&
-            &  "be specified.")
+            CALL logger_warn("MPP INIT: number of processor to be used "//&
+            &                "not specify. force to one.")
+            mpp__init_mask%i_nproc  = 1
+            ! optimiz
+            CALL mpp__optimiz( mpp__init_mask, id_mask )
          ENDIF
+         CALL logger_info("MPP INIT: domain decoposition : "//&
+         &  'niproc('//TRIM(fct_str(mpp__init_mask%i_niproc))//') * '//&
+         &  'njproc('//TRIM(fct_str(mpp__init_mask%i_njproc))//') = '//&
+         &  'nproc('//TRIM(fct_str(mpp__init_mask%i_nproc))//')' )
 
          ! get domain type
@@ -593,4 +774,6 @@
             mpp__init_mask%t_proc(ji)%c_type=TRIM(mpp__init_mask%c_type)
 
+            ! clean
+            CALL dim_clean(tl_dim)
          ENDDO
 
@@ -640,12 +823,13 @@
          CALL mpp_add_att(mpp__init_mask, tl_att)         
 
+         ! clean
+         CALL att_clean(tl_att)
       ENDIF
 
    END FUNCTION mpp__init_mask
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !> This function initialised mpp structure, given variable strcuture 
-   !> and number of processor following I and J
+   !> This function initialise mpp structure, given variable strcuture 
+   !> and optionaly number of processor following I and J
    !> @detail
    !> - If no total number of processor is defined (id_nproc), optimize 
